addNode {XML} | R Documentation

## Add a node to a tree

### Description

This generic function allows us to add a node to a tree for different types of trees. Currently it just works for XMLHashTree, but it could be readily extended to the more general XMLFlatTree class. However, the concept in this function is to change the tree and return the node. This does not work unless the tree is directly mutable without requiring reassignment, i.e. the changes do not induce a new copy of the original tree object. DOM trees which are lists of lists of lists do not fall into this category.

### Usage

    addNode(node, parent, to, ...)

### Arguments

`node` | the node to be added as a child of the parent.
`parent` | the parent node or identifier
`to` | the tree object
`...` | additional arguments that are understood by the different methods for the different types of trees/nodes. These can include `attrs`, `namespace`, `namespaceDefinitions`, `.children`.

### Value

The new node object. For flat trees, this will be the `node` after it has been coerced to be compatible with a flat tree, i.e. has an id and the host tree added to it.

### Author(s)

Duncan Temple Lang

### References

http://www.w3.org

### See Also

`xmlHashTree` `asXMLTreeNode`

### Examples

      tt = xmlHashTree()

      top = addNode(xmlNode("top"), character(), tt)
      addNode(xmlNode("a"), top, tt)
      b = addNode(xmlNode("b"), top, tt)
      c = addNode(xmlNode("c"), b, tt)
      addNode(xmlNode("c"), top, tt)
      addNode(xmlNode("c"), b, tt)
      addNode(xmlTextNode("Some text"), c, tt)

      xmlElementsByTagName(tt$top, "c")

      tt

[Package XML version 3.98-1.4 Index]